package com.steerinfo.meterwork.meterworkzeroalarm.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkstorageactual.model.MeterWorkStorageActual;
import com.steerinfo.meterwork.meterworkzeroalarm.model.MeterWorkZeroAlarm;
import com.steerinfo.meterwork.meterworkzeroalarm.service.IMeterWorkZeroAlarmService;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkZeroAlarm RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-11-20 11:16
 * 类描述
 * 修订历史：
 * 日期：2021-11-20
 * 作者：generator
 * 参考：
 * 描述：MeterWorkZeroAlarm RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkzeroalarms")
public class MeterWorkZeroAlarmController extends BaseRESTfulController {

    @Autowired
    IMeterWorkZeroAlarmService meterWorkZeroAlarmService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkzeroalarm:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkZeroAlarm> list = meterWorkZeroAlarmService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkzeroalarm:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkZeroAlarm> list = meterWorkZeroAlarmService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkzeroalarm:view")
    @GetMapping(value = "/likeByDesc/")
    public RESTfulResult likeByDesc(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkZeroAlarm> list = meterWorkZeroAlarmService.likeByDesc(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkZeroAlarm对象创建")
    @ApiImplicitParam(name = "meterWorkZeroAlarm", value = "详细实体meterWorkZeroAlarm", required = true, dataType = "MeterWorkZeroAlarm")
    //@RequiresPermissions("meterworkzeroalarm:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkZeroAlarm model){
        MeterWorkZeroAlarm meterWorkZeroAlarm = meterWorkZeroAlarmService.add(model);
        return success(meterWorkZeroAlarm);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkzeroalarm:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkZeroAlarm meterWorkZeroAlarm = meterWorkZeroAlarmService.getById(id);
        return success(meterWorkZeroAlarm);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkZeroAlarm信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkZeroAlarm", value = "详细实体meterWorkZeroAlarm", required = true, dataType = "MeterWorkZeroAlarm")
    })
    //@RequiresPermissions("meterworkzeroalarm:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkZeroAlarm model){
        model.setId(id);
        MeterWorkZeroAlarm meterWorkZeroAlarm = meterWorkZeroAlarmService.modify(model);
        return success(meterWorkZeroAlarm);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkzeroalarm:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkZeroAlarmService.delete(ids);
    	}
      return success();
    }


    @ApiOperation(value = "新增零点报警的数据", notes = "客户端记录零点报警的值")
    @Transactional(rollbackFor = {MarkerMetException.class, Exception.class})
    @PostMapping(value = "/doInsertZeroAlarm")
    public RESTfulResult doInsertZeroAlarm(@RequestBody MeterWorkZeroAlarm model) {
        RESTfulResult rm = failed();
        try {
            String str = meterWorkZeroAlarmService.doInsertZeroAlarm(model);
            if (StringUtils.isEmpty(str)) {
                return success();
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！" + e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
}
